/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/3/practice/contest/280799/problem/A */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    int prev = n;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }

    struct node {
        ll pref;
        ll suf;
        ll total;
        ll ans;
    };

    V<node> seg(n * 2);
    vl lazy(n * 2);
    V<bool> upd(n * 2);

    auto propagate = [&](int i, int l, int r) {
        if (!upd[i]) {
            return;
        }

        upd[i] = false;

        if (i >= n) {
            seg[i].total = lazy[i];
            seg[i].suf = max(lazy[i], 0LL);
            seg[i].pref = max(lazy[i], 0LL);
            seg[i].ans = max(lazy[i], 0LL);
            return;
        }

        lazy[i * 2] = lazy[i];
        lazy[i * 2 + 1] = lazy[i];
        upd[i * 2] = true;
        upd[i * 2 + 1] = true;

        ll ans = lazy[i] * (r - l + 1);

        seg[i].total = ans;
        seg[i].suf = max(ans, 0LL);
        seg[i].pref = max(ans, 0LL);
        seg[i].ans = max(ans, 0LL);
    };

    auto merge = [&](node &a, node &b) {
        node ans;

        ans.total = a.total + b.total;
        ans.pref = max(a.pref, a.total + b.pref);
        ans.suf = max(b.suf, b.total + a.suf);
        ans.ans = max({a.pref, b.suf, a.suf + b.pref, a.ans, b.ans});

        return ans;
    };

    function<void(int, int, int, int, int, ll)> update = [&](int i, int l, int r, int tl, int tr, ll v) {
        propagate(i, l, r);

        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazy[i] = v;
            upd[i] = true;
            propagate(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, v);

        seg[i] = merge(seg[i * 2], seg[i * 2 + 1]);
    };

    function<node(int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr) -> node {
        if (l > tr || r < tl) {
            return {.pref=0, .suf=0, .total=0, .ans=0};
        }

        if (l >= tl && r <= tr) {
            return seg[i];
        }

        int mid = (l + r) >> 1;

        node left = query(i * 2, l, mid, tl, tr);
        node right = query(i * 2 + 1, mid + 1, r, tl, tr);

        return merge(left, right);
    };

    while (m--) {
        int l, r;
        ll v;
        cin >> l >> r >> v;

        update(1, 0, n - 1, l, r - 1, v);

        cout << query(1, 0, n - 1, 0, prev - 1).ans << '\n';
    }
}
